# coding: utf-8
from StringIO import StringIO

from caty.jsontools.path.query import JsonPathQuery
from caty.jsontools.path.validator import JsonValidatorBuilder
from caty.jsontools.path.JsonPathLexer import Lexer

def build_query(query):
    io = StringIO()
    io.write(query)
    io.seek(0)
    lexer = Lexer(io)
    parser = JsonPathQuery(lexer)
    parser.parse_jsonpath()
    return parser

def build_validator(expression):
    io = StringIO()
    io.write(expression)
    io.seek()
    lexer = Lexer(io)
    parser = JsonValidatorBuilder(lexer)
    parser.parse_jsonpath()
    return parser.build_schema()

