header {
class JsonPathError(Exception):
    pass
class Undefined(object):
    pass
undefined = Undefined()
}

options {
    language = "Python";
}


class JsonPathParser extends Parser;
    {
        def _root(self, token):
            raise JsonPathError("Syntax Error")
        def _path(self, token):
            raise JsonPathError("Syntax Error")
        def _schema_type(self, token):
            raise JsonPathError("Syntax Error")
    }

    parse_jsonpath:(
        r:ROOT {
            self._root(r)
        }
        | p:PATH {
            self._path(p)
        }
        | s:SCHEMATYPE {
            self._schema_type(s)
        }
    )*;
    
class JsonPathLexer extends Lexer;

options {
    k=1;
    filter=true;
    charVocabulary = '\u0000'..'\uFFFE';
}

ROOT : '$';

PATH : '.'! (NAME|'*'|'#'|NUMBER);

NAME : ('a'..'z'|'A'..'Z')('a'..'z'|'A'..'Z')*;

protected
NUMBER : ('0'..'9')('0'..'9')*;

SCHEMATYPE : ':'! STRINGBLOCK;

protected
STRINGBLOCK: (CHAR)+;

NL : ('\n'|';') { $skip };

WS : (' '|'\t') { $skip };

protected
CHAR: ~(';' | '\n');

