#coding:utf-8
import re
from topdown import *
from caty.jsontools.schema.language.util import *
from caty.jsontools.schema.language.schemaparser import schema
from caty.jsontools.schema.language.commandparser import command
u"""
casm -> head (schema|command)*
head -> provides name (',' name)*
schema -> typedecl | command
typedecl -> 'type' name '=' typedef ';'
typedef -> term op typedef | term
op -> '&' | '|'
term -> ('@' name term | '(' typedef ')' | scalar | enum | object ) ?
scalar -> typename options? underlyingtypes? '?'?
typename -> name | package ':' name
package -> name | name '.' name
options -> '(' optval (',' optval)* ')'
optval -> name '=' value
underlyingtypes -> '[' scalar '*'? (',' scalar '*'?)* ']'
enum -> name '[' value ']' '?'?
value -> string|integer|boolean
string -> '"' .* '"'
integer -> -?[0-9]+
boolean -> 'true' | 'false'
"""
def parse(t):
    try:
        return as_parser(casm).run(remove_comment(t), auto_remove_ws=True)
    except ParseFailed, e:
        raise SchemaSyntaxError(e)

def iparse(t):
    try:
        return (i for i in as_parser(casm).run(remove_comment(t), auto_remove_ws=True))
    except ParseFailed, e:
        raise SchemaSyntaxError(e)

def casm(seq):
    s = []
    p = option(provides)(seq)
    if p:
        s.append(p)
    while not seq.eof:
        s.append(seq.parse([schema, command]))
    return s

def provides(seq):
    _ = seq.parse('provides ')
    names = chain_flat(name, comma)
    return Provide(names)

comment1 = re.compile(r'//.+')
comment2 = re.compile(r'/\*[^*].+?\*/', re.S)
def remove_comment(s):
    return comment1.sub('', comment2.sub('', s))

