# coding:utf-8
from topdown import *
import re

__all__ = ['name', 'comma', 'chain_flat', 'docstring', 'SchemaSyntaxError']

def name(seq):
    return seq.parse(Regex(r'(([a-zA-Z_][a-zA-Z0-9_]*)|(\$))'))

def comma(seq):
    _ = seq.parse(',')
    return _

class chain_flat(Parser):
    def __init__(self, parser, op):
        self.parser = parser
        self.op = op

    def __call__(self, seq):
        r = []
        r.append(seq.parse(self.parser))
        while True:
            try:
                a = seq.parse(self.op)
                b = seq.parse(self.parser)
            except ParseFailed, e:
                break
            else:
                #カンマへの対応のみなので、 op の結果は捨てる
                r.append(b)
        return r

def docstring(seq):
    return seq.parse(Regex(r'/\*\*.+?\*/', re.S))

class SchemaSyntaxError(Exception):
    def __init__(self, exception):
        self.exception = exception

    def __str__(self):
        return str(self.exception)

    def __repr__(self):
        return repr(self.exception)


