# coding: utf-8
import sys
import os
sys.path.insert(0, os.path.abspath('../../../'))
from caty.jsontools.schema import *
from caty.testutil import TestCase

class ArraySchemaTest(TestCase):
    def test_validate_ok(self):
        scm = ArraySchema(maxItems=10, optional=True, repeat=True)._apply_udt([NumberSchema(is_integer=True), StringSchema()])
        self.assertNotRaises(scm.validate, [])
        self.assertNotRaises(scm.validate, [0])
        self.assertNotRaises(scm.validate, [0, u'1', u'2', u'3', u'4', u'5', u'6', u'7', u'8', u'9'])

    def test_type_error(self):
        scm = ArraySchema(repeat=True)._apply_udt([StringSchema()])
        self.assertRaises(JsonSchemaError, scm.validate, [u'a', u'b', 1])
        self.assertRaises(JsonSchemaError, scm.validate, [True])
        self.assertRaises(JsonSchemaError, scm.validate, u'a')

    def test_overflow_max(self):
        scm = ArraySchema(maxItems=10, repeat=True)._apply_udt([NumberSchema(is_integer=True)])
        self.assertNotRaises(scm.validate, list(range(10)))
        self.assertRaises(JsonSchemaError, scm.validate, list(range(11)))

    def test_convert(self):
        scm = ArraySchema(repeat=True)._apply_udt([StringSchema(), BoolSchema(), NumberSchema(is_integer=True)])
        converted = [u'abc', True, 1, 2]
        converted = scm.convert(['abc', 'True', '1', '2'])


