# coding: utf-8
import sys
import os
sys.path.insert(0, os.path.abspath('../../../'))
import unittest
from caty.jsontools.schema import *

class BoolSchemaTest(unittest.TestCase):
    def test_validate_ok(self):
        scm = BoolSchema()
        try:
            scm.validate(True)
            scm.validate(False)
        except Exception, e:
            self.fail(e)

    def test_type_error(self):
        scm = BoolSchema()
        self.assertRaises(JsonSchemaError, scm.validate, 0)
        self.assertRaises(JsonSchemaError, scm.validate, 'a')

    def test_convert(self):
        scm = BoolSchema()
        v = scm.convert('True')
        self.assertEquals(True, v)
        v = scm.convert('true')
        self.assertEquals(True, v)
        v = scm.convert('False')
        self.assertEquals(False, v)
        v = scm.convert('false')
        self.assertEquals(False, v)

