# coding: utf-8
import sys
import os
sys.path.insert(0, os.path.abspath('../../../'))
from caty.jsontools.schema import *
from caty.jsontools.model import *
from caty.testutil import TestCase

string = StringSchema()
integer = NumberSchema(is_integer=True)

class IntersectionSchemaTest(TestCase):
    def test_validate_ok(self):
        scm1 = ObjectSchema()
        scm1.schemas = {'a': string}
        scm2 = ObjectSchema()
        scm2.schemas = {'b': integer}
        i = scm1 & scm2
        self.assertNotRaises(i.validate, {'a': u'foo', 'b': 1})
        self.assertNotRaises(i.validate, {'a': u'foo', 'b': 1, 'c': True})

    def test_type_error(self):
        scm1 = ObjectSchema()
        scm1.schemas = {'a': string}
        scm2 = ObjectSchema()
        scm2.schemas = {'b': integer}
        i = scm1 & scm2
        self.assertRaises(JsonSchemaError, i.validate, {'a': u'foo'})
        self.assertRaises(JsonSchemaError, i.validate, {'b': 1})
        self.assertRaises(JsonSchemaError, i.validate, None)


