# coding: utf-8
import sys
import os
sys.path.insert(0, os.path.abspath('../../../'))
import unittest
from caty.jsontools.schema import *

class NumberSchemaTest(unittest.TestCase):
    def test_validate_ok(self):
        scm = NumberSchema()
        try:
            scm.validate(0.0)
            scm.validate(1.0)
            scm.validate(-1.0)
            scm.validate(1)
        except Exception, e:
            self.fail(e)

    def test_validate_less_than_minimum(self):
        scm = NumberSchema(minimum=10.0)
        self.assertRaises(JsonSchemaError, scm.validate, 9.0)
        try:
            scm.validate(10.0)
        except Exception, e:
            self.fail(e)
    
    def test_validate_greater_than_maximum(self):
        scm = NumberSchema(maximum=10.0)
        self.assertRaises(JsonSchemaError, scm.validate, 11.0)
        try:
            scm.validate(10.0)
        except Exception, e:
            self.fail(e)

    def test_type_error(self):
        scm = NumberSchema()
        self.assertRaises(JsonSchemaError, scm.validate, '1')
        self.assertRaises(JsonSchemaError, scm.validate, 'a')

    def test_convert(self):
        scm = NumberSchema(maximum=10.0)
        v = scm.convert('1.1')
        self.assertEquals(1.1, v)
        v = scm.convert('1')
        self.assertEquals(1, v)
        self.assertRaises(ValueError, scm.convert, 'a')
        self.assertRaises(JsonSchemaError, scm.convert, '12.0')

