# coding: utf-8
import sys
import os
sys.path.insert(0, os.path.abspath('../../../'))
from caty.jsontools.schema import *
from caty.testutil import TestCase

class TupleSchemaTest(TestCase):
    def test_validate_ok(self):
        scm = TupleSchema()._apply_udt([NumberSchema(is_integer=True), StringSchema()])
        self.assertNotRaises(scm.validate, (0, u'a'))

    def test_type_error(self):
        scm = TupleSchema()._apply_udt([NumberSchema(is_integer=True), StringSchema()])
        self.assertRaises(JsonSchemaError, scm.validate, (u'a', u'b'))
        self.assertRaises(JsonSchemaError, scm.validate, (0, 1))
        self.assertRaises(JsonSchemaError, scm.validate, (u'b', 1))

    def test_convert(self):
        scm = TupleSchema()._apply_udt([NumberSchema(is_integer=True), StringSchema()])
        converted = (0, u'a')
        converted = scm.convert(('0', 'a'))




