# coding: utf-8
import sys
import os
sys.path.insert(0, os.path.abspath('../../../'))
from caty.jsontools.schema import *
from caty.jsontools.model import *
from caty.testutil import TestCase

class UnionSchemaTest(TestCase):
    def test_validate_ok(self):
        scm1 = ListSchema()._apply_udt([NumberSchema(is_integer=True)])
        scm2 = NumberSchema(is_integer=True)
        union = scm1 | scm2
        self.assertNotRaises(union.validate, [0])
        self.assertNotRaises(union.validate, 1)

    def test_tag_validate(self):
        scm1 = TagSchema('foo', ListSchema()._apply_udt([NumberSchema(is_integer=True)]))
        scm2 = TagSchema('bar', NumberSchema(is_integer=True))
        union = scm1 | scm2
        v1 = to_tagged_value('foo', [0])
        v2 = to_tagged_value('bar', 0)
        self.assertNotRaises(union.validate, v1)
        self.assertNotRaises(union.validate, v2)

    def test_type_error(self):
        scm1 = ListSchema()._apply_udt([NumberSchema(is_integer=True)])
        scm2 = NumberSchema(is_integer=True)
        union = scm1 | scm2
        self.assertRaises(JsonSchemaError, union.validate, True)
        self.assertRaises(JsonSchemaError, union.validate, [u'a'])
        self.assertRaises(JsonSchemaError, union.validate, None)


