
# coding: utf-8
import sys
import os
sys.path.insert(0, os.path.abspath('../../../'))
import unittest
import caty.jsontools as json

class JsonTest(unittest.TestCase):
    def test_load(self):
        open('test.json', 'wb').write('{"a": "foo", "b":1, "c": {"d": 2}}')
        try:
            fo = open('test.json')
            j = json.load(fo)
            self.assertEquals('foo', j.a)
            self.assertEquals(1, j.b)
            self.assertEquals(2, j.c.d)
        finally:
            os.remove('test.json')

    def test_loads(self):
        s = '{"a": "foo", "b":1, "c": {"d": 2}}'
        j = json.loads(s)
        self.assertEquals('foo', j.a)
        self.assertEquals(1, j.b)
        self.assertEquals(2, j.c.d)

    def test_dump(self):
        j = json.JsonModel({"a": "b"})
        try:
            fo = open('test.json', 'wb')
            json.dump(j, fo)
            fo.close()
            loaded = json.load(open('test.json'))
            self.assertEquals(j, loaded)
        finally:
            os.remove('test.json')

    def test_dumps(self):
        j = json.JsonModel({"a": "b"})
        s = json.dumps(j)
        self.assertEquals(json.loads(s), j)

if __name__ == '__main__': 
    result = unittest.TestResult()
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(JsonTest))
    suite.run(result)
    if not result.wasSuccessful():
        print '--------'.join(('%s:\n%s' % (f[0]._testMethodName, f[1]) for f in result.failures + result.errors))
        sys.exit(1)
