
header {
class ScriptSyntaxError(Exception):
    pass
}

options {
    language = "Python";
}

class CatyScriptLexer extends Lexer;

options {
    k=3;
    filter=true;
    charVocabulary = '\u0000'..'\uFFFE';
}

LBRACE : '{';
RBRACE : '}';
LBRACKET : '[';
RBRACKET : ']';
OPTION: SHORTOPT | LONGOPT;
protected
SHORTOPT: '-' ('a'..'z'|'A'..'Z');
protected
LONGOPT: "--" STRING;
STRING : (NO_NUM_CHAR|ESCAPEDCHAR)(CHAR|ESCAPEDCHAR)*;
QSTRING : ('"') (~'"')* ('"');
SUBSTITUTION : ':';
LSUBSTITUTION : ">:";
PIPE : '|';
COMMA : ',';
LPAREN : '(';
RPAREN : ')';
CASE : "=>";
DELIMTAGCASE : "=>>";
WS : (' ') {$skip;};
LF : '\n';
NUMBER : ('-')? ('1'..'9')('.'|'0'..'9')* ;
protected
CHAR: ~('('|')'|'{' | '}' | '|' | ' ' | ':' | '>' | '<' | '"' | ',' | '=' | '\n' | '[' | ']');

protected
NO_NUM_CHAR: ~('0'..'9' | '(' | ')' | '{' | '}' | '|' | ' ' | ':' | '>' | '<' | '"' | ',' | '-' | '=' | '\n' | '[' | ']');

protected
ESCAPEDCHAR: '\\'! ('('|')'|'{' | '}' | '|' | ' ' | ':' | '>' | '<' | '"' | ',' | '=' | '[' | ']');

