# coding: utf-8
import sys
import os
sys.path.insert(0, os.path.abspath('../../../../'))
from caty.shell.system import setup_caty
from caty.mafs.authorization import AuthoriToken
open('config.json', 'wb').write('{"mafs":{"filesystem":"caty.mafs.stdfs", "root_directory":"%s"}}' % os.getcwd())
setup_caty('config.json')
from caty.mafs import filesystem as fs
fs = fs.bind_token(AuthoriToken('admin'))
import caty.jsontools as json
from caty.shell.script.builtin import *
from caty.shell.script.cmdbase import *
from caty.jsontools.schema import Registrar
from caty.testutil import TestCase, test
from StringIO import StringIO

registrar = Registrar.get_instance(fs)
apply_schema_builtin(Print, registrar)

class PrintTest(TestCase):
    expected = """
<p>Literal</p>
foo! 
<p>buz!</p>

    <p>Boooo!</p>


    data=qwerty
    index=0
    iteration=1
    first=True
    last=False

    data=azerty
    index=1
    iteration=2
    first=False
    last=False

    data=dvorak
    index=2
    iteration=3
    first=False
    last=True
""".strip()

    def testPrint(self):
        u"""テンプレートを展開"""
        src = open('test.json')
        p = Print(fs, None, ['/test.html', '-v'])
        p.input = json.loads(src.read())
        r = p()
        self.assertEquals(self.expected, p.output['body'].strip())
        self.assertEquals(0, r)

    def testPrintRaw(self):
        u"""テンプレートを展開せずにそのまま出力。
        """
        src = open('test.json')
        dest = StringIO()
        p = Print(fs, None, ['/test.html', '-r'])
        p.input = json.loads(src.read())
        r = p()
        expected = open('test.html').read()
        self.assertEquals(expected.strip(), p.output.body.strip())
        self.assertEquals(0, r)

    def testErr(self):
        u"""テンプレートの展開に失敗した場合。
        """
        src = StringIO('{"a":1}')
        dest = StringIO()
        p = Print(fs, None, ['/test.html'])
        p.input = json.loads(src.read())
        r = p()
        self.assertEquals(-1, r)

if __name__ == '__main__': 
    test(PrintTest)
