# coding: utf-8
import sys
import os
sys.path.insert(0, os.path.abspath('../../../'))
from caty.testutil import *
from caty.shell.session import *
from caty.jsontools.schema import *

class SessionValueTest(TestCase):
    def test_to_dict(self):
        sv = SessionValue(repository.string, u'aaa', False)
        self.assertEquals({'json_type': repository.string, 'value': 'aaa', 'addable': False}, sv._to_dict())

class SessionTest(TestCase):
    def test_exists(self):
        s = Session('key')
        self.assertFalse(s.exists('name'))
        s.put('name', StringSchema(), u'value')
        self.assertTrue(s.exists('name'))
    
    def test_addable(self):
        s = Session('key')
        s.put('name1', StringSchema(), u'value')
        self.assertFalse(s.addable('name1'))
        s.put('name2', ArraySchema(repeat=True, optional=True)[StringSchema()], [], True)
        self.assertTrue(s.addable('name2'))
        s.put('name3', ArraySchema(repeat=True)[StringSchema()], [u'1'])
        self.assertFalse(s.addable('name3'))
        try:
            s.put(u'name1', u'type', u'value', True)
            self.fail()
        except Exception, e:
            pass

    def test_put_and_get(self):
        s = Session('key')
        s.put('name', IntegerSchema(), 1)
        self.assertEquals(1, s.get('name'))

test(SessionValueTest, SessionTest)

