# coding: utf-8
LOAD = 0 # LOAD <KEY>: コンテキストからデータを取得し、スタックに積む
PUSH = 1 # PUSH <DATA>: 無名のデータをスタックに積む。このデータは数値か文字列のリテラルとする
POP = 2 # POP: スタックから値を一つポップする（POP されたデータはインタープリタの callee に渡される）
LABEL = 3 # LABEL <NAME>: ラベルを定義する（JMP で使用する）
JMP = 4 # JMP <NAME>: NAME で指定されたラベルにジャンプする
JMPUNLESS = 5 # JMPUNLESS <NAME>: スタックから値をポップし、その値が偽であればラベルにジャンプする
NEWCTX = 6 # NEWCTX: コンテキストリストを伸長する
DELCTX = 7 # DELCTX: コンテキストリストの最初の要素を削除する（初期コンテキストを削除してはならない）
CPUSH = 8 # CPUSH <KEY>: スタックからポップした値をコンテキストに <NAME> というキーで追加（初期コンテキストには NG）
MACRO = 9 # MACRO <KEY>: <NAME> という名前のマクロ定義を開始（現状入れ子不可）
RETURN = 10 # RETURN: マクロの終了。スタックから戻り先アドレスをポップし、そこにジャンプする
EXPAND = 11 # EXPAND <NAME>: NAME で指定されたマクロを呼び出す
STRING = 12 # STR <LITERAL>: 文字列リテラルを callee に渡す
DEFINED = 13 # DEFINED <KEY>: コンテキストに KEY があれば True を、そうでなければ False をスタックに積む
CALL = 14 # CALL <NAME> <ARGC>: ARGC 個の引数で NAME 関数を呼び出し、戻り値をスタックに積む
INCLUDE = 15 # INCLUDE <NAME>: NAME で指定された別のテンプレートを呼び出す。事実上マクロと同じ
NOT = 16 # NOT: スタックトップの値を真偽反転する
ADD = 17 # ADD: スタックから値を二つ取り、それらを加算した値をスタックに積む
EQ = 18 # EQ: スタックから値を二つ取り、それらが等しいかどうかの結果をスタックに積む
LT = 19 # LT: EQ と同様に、最初にポップした要素の方が小さいかどうかをスタックに積む
LE = 20 # LE: LT と大体同じ
LEN = 21 # LEN <KEY>: コンテキストから値を取り、その長さをスタックに積む
AT = 22 # AT: スタックから値を二つ取り、最初にポップしたデータを添字、二番目のものを配列として取得した値をスタックに積む
REFCONTEXT = 23 # REFCONTEXT: 現在のコンテキストをスタックに積む
EXE_CMD = 24 # EXE_CMD <COMMANDS>: コマンドインタープリタにコマンドを渡し、返されたコマンドを実行。戻り値をコンテキストにマージする

def get_name(code):
    d = {}
    for k, v in globals().items():
        if k[0].isupper() and k[-1].isupper():
            d[v] = k
    return d.get(code, 'UNKNOWN')

