# coding: utf-8
from caty.template.core.template import Template
from caty.template.core.loader import BytecodeLoader, TextBytecodePersister
from caty.template.core.compiler import Compiler
from caty.template.core.io import ResourceIO
from caty.template.smarty.SmartyLexer import Lexer
from caty.template.smarty.SmartyParser import Parser
from caty.template.genshi.htmlverifier import convert
from caty.template.genshi.translator import GenshiTranslator
from caty.template.builder import build_template
import sys
__all__ =['GenshiTemplate', 'build_compiler']
class FakeLexer(object):
    def __init__(self, path_or_file):
        if isinstance(path_or_file, basestring):
            self.fo = open(path_or_file)
        else:
            self.fo = path_or_file

class FakeParser(object):
    def __init__(self, lexer):
        self.fo = lexer.fo

    def parse_template(self):
        gt = GenshiTranslator()
        gt.feed(convert(self.fo.read()))
        self.parser = Parser(Lexer(gt.buffer))
        parser.parse_template()

    def generate(self):
        return self.parser.generate()

def GenshiTemplate(template, encoding=sys.getdefaultencoding()):
    u"""スタンドアローンで動作する Gneshi 風テンプレートエンジンを作成する。
    """
    compiler = build_compiler()
    resource_io = ResourceIO()
    t = build_template(compiler, resource_io)
    return t

def build_compiler():
    u"""リソース IO やローダーまでは初期化せず、
    テンプレートのコンパイラまでを作成する。
    """
    compiler = Compiler(FakeLexer, FakeParser)
    return compiler

