### $ANTLR 2.7.7 (20090605): "smarty.g" -> "SmartyParser.py"$
### import antlr and other modules ..
import sys
import antlr

version = sys.version.split()[0]
if version < '2.2.1':
    False = 0
if version < '2.3':
    True = not False
### header action >>> 
import sys
from StringIO import StringIO
import SmartyExprLexer
import caty.template.core.instructions as ins
from caty.template.core.vm import Bytecode, Stack, TemplateRuntimeError
### header action <<< 
### preamble action>>>

### preamble action <<<

### import antlr.Token 
from antlr import Token
### >>>The Known Token Types <<<
SKIP                = antlr.SKIP
INVALID_TYPE        = antlr.INVALID_TYPE
EOF_TYPE            = antlr.EOF_TYPE
EOF                 = antlr.EOF
NULL_TREE_LOOKAHEAD = antlr.NULL_TREE_LOOKAHEAD
MIN_USER_TYPE       = antlr.MIN_USER_TYPE
IF = 4
IFNOT = 5
ELSEIF = 6
ELSE = 7
ENDIF = 8
FOREACH = 9
ENDFOR = 10
INCLUDE = 11
EXPR = 12
LITERAL = 13
ACTION = 14
NL = 15
COMMENT = 16
IF_EXPR = 17
FILTER = 18
FILTER_ARGS = 19
VARIABLE = 20
FOREACH_EXPR = 21
LOOP_VAR = 22
LOOP_ITEM = 23
LOOP_NAME = 24
INC_EXPR = 25
NO_ESC = 26
SYMBOL = 27

class Parser(antlr.LLkParser):
    ### user action >>>
    def generate(self):
       def _():
           for x in self.codes:
               yield Bytecode(x[0], x[1])
       return tuple(list(_()))
    
    def createLoadingVariableCode(self, e):
       filter = None
       argc = 0
       for token in SmartyExprLexer.Lexer(StringIO(e.getText())):
           t = token.getType()
           s = token.getText()
           if t == SmartyExprLexer.VARIABLE:
               varname = s.replace("->", ".")
               b = (ins.LOAD, varname)
               self.codes.append(b)
           elif t == SmartyExprLexer.FILTER:
               if filter:
                   b = (ins.CALL, (filter, argc))
                   self.codes.append(b)
                   argc = 0
               filter = s
           elif t == SmartyExprLexer.FILTER_ARGS:
               b = (ins.PUSH, s)
               self.codes.append(b)
               argc += 1
           elif t == SmartyExprLexer.INDEX:
               self.codes.append((ins.PUSH, int(s)))
               self.codes.append((ins.AT, None))
       if filter:
           b = (ins.CALL, filter, argc)
           self.codes.append(b)
    
    def createIfCode(self, i):
       self.createLoadingVariableCode(i)
       v = i.getText()
       label = str(id(i))
       while label in self.used_label:
           label = str(id(label))
       self.used_label.add(label)
       self.if_label_stack.push(label)
       if v.startswith('!'):
           self.code.append((INS.NOT, None))
           b = (ins.JMPUNLESS, label)
       else:
           b = (ins.JMPUNLESS, label)
       self.codes.append(b)
    ### user action <<<
    
    def __init__(self, *args, **kwargs):
        antlr.LLkParser.__init__(self, *args, **kwargs)
        self.tokenNames = _tokenNames
        ### __init__ header action >>> 
        self.used_label = set()
        self.if_label_stack = Stack()
        self.upcoming_end_stack = Stack()
        self.for_label_stack = Stack()
        self.codes = [] # list of tuple(INSTRUCTION, VALUE)
        ### __init__ header action <<< 
        
    def tokenDefinitions(self):    
        
        try:      ## for error handling
            pass
            self.match(IF)
            self.match(IFNOT)
            self.match(ELSEIF)
            self.match(ELSE)
            self.match(ENDIF)
            self.match(FOREACH)
            self.match(ENDFOR)
            self.match(INCLUDE)
        
        except antlr.RecognitionException, ex:
            self.reportError(ex)
            self.consume()
            self.consumeUntil(_tokenSet_0)
        
    
    def parse_template(self):    
        
        e = None
        i = None
        ei = None
        el = None
        en = None
        fo = None
        ef = None
        l = None
        inc = None
        try:      ## for error handling
            pass
            while True:
                la1 = self.LA(1)
                if False:
                    pass
                elif la1 and la1 in [EXPR]:
                    pass
                    e = self.LT(1)
                    self.match(EXPR)
                    self.createLoadingVariableCode(e)
                    b = (ins.POP, None)
                    self.codes.append(b)
                elif la1 and la1 in [IF]:
                    pass
                    i = self.LT(1)
                    self.match(IF)
                    self.createIfCode(i)
                    self.upcoming_end_stack.push(self.if_label_stack.top() + "end")
                elif la1 and la1 in [ELSEIF]:
                    pass
                    ei = self.LT(1)
                    self.match(ELSEIF)
                    self.codes.append((ins.JMP, self.upcoming_end_stack.top()))
                    self.codes.append((ins.LABEL, self.if_label_stack.pop()))
                    self.createIfCode(ei)
                elif la1 and la1 in [ELSE]:
                    pass
                    el = self.LT(1)
                    self.match(ELSE)
                    self.codes.append((ins.JMP, self.upcoming_end_stack.top()))
                    self.codes.append((ins.LABEL, self.if_label_stack.pop()))
                elif la1 and la1 in [ENDIF]:
                    pass
                    en = self.LT(1)
                    self.match(ENDIF)
                    if not self.if_label_stack.is_empty():
                       self.codes.append((ins.LABEL, self.if_label_stack.pop()))
                    if not self.upcoming_end_stack.is_empty():
                       self.codes.append((ins.LABEL, self.upcoming_end_stack.pop()))
                elif la1 and la1 in [FOREACH]:
                    pass
                    fo = self.LT(1)
                    self.match(FOREACH)
                    label = str(id(fo))
                    while label in self.used_label:
                       label = str(id(label))
                    self.used_label.add(label)
                    loop_var = ""
                    loop_item = ""
                    loop_key = ""
                    loop_name = ""
                    for token in SmartyExprLexer.Lexer(StringIO(fo.getText())):
                       t = token.getType()
                       s = token.getText()
                       if t == SmartyExprLexer.LOOP_VAR:
                           loop_var = s
                       elif t == SmartyExprLexer.LOOP_KEY:
                           loop_key = s
                       elif t == SmartyExprLexer.LOOP_ITEM:
                           loop_item = s
                       elif t == SmartyExprLexer.LOOP_NAME:
                           loop_name = s
                    if not loop_var or not loop_item:
                       raise TemplateRuntimeError("Syntax error: %s" % fo.getText())
                    if not loop_name:
                       loop_name = "default"
                    index_name = "smarty.foreach.%s.index" % loop_name
                    iteration_name = "smarty.foreach.%s.iteration" % loop_name
                    counter_name = "smarty.foreach.%s.total" % loop_name
                    first = "smarty.foreach.%s.first" % loop_name
                    last = "smarty.foreach.%s.last" % loop_name
                    self.codes.append((ins.NEWCTX, None))
                    self.codes.append((ins.PUSH, -1))
                    self.codes.append((ins.CPUSH, index_name))
                    self.codes.append((ins.PUSH, 0))
                    self.codes.append((ins.CPUSH, iteration_name))
                    self.codes.append((ins.LEN, loop_var))
                    self.codes.append((ins.CPUSH, counter_name))
                    
                    self.codes.append((ins.LABEL, label))
                    
                    self.codes.append((ins.LOAD, index_name))
                    self.codes.append((ins.PUSH, 1))
                    self.codes.append((ins.ADD, None))
                    self.codes.append((ins.CPUSH, index_name))
                    
                    self.codes.append((ins.LOAD, iteration_name))
                    self.codes.append((ins.PUSH, 1))
                    self.codes.append((ins.ADD, None))
                    self.codes.append((ins.CPUSH, iteration_name))
                    
                    self.codes.append((ins.PUSH, 0))
                    self.codes.append((ins.LOAD, index_name))
                    self.codes.append((ins.EQ, None))
                    self.codes.append((ins.CPUSH, first))
                    
                    self.codes.append((ins.LOAD, counter_name))
                    self.codes.append((ins.LOAD, iteration_name))
                    self.codes.append((ins.EQ, None))
                    self.codes.append((ins.CPUSH, last))
                    
                    self.codes.append((ins.LOAD, loop_var))
                    self.codes.append((ins.LOAD, index_name))
                    self.codes.append((ins.AT, None))
                    self.codes.append((ins.CPUSH, loop_item))
                    
                    self.for_label_stack.push((label, last))
                elif la1 and la1 in [ENDFOR]:
                    pass
                    ef = self.LT(1)
                    self.match(ENDFOR)
                    label, last = self.for_label_stack.pop()
                    self.codes.append((ins.LOAD, last))
                    self.codes.append((ins.JMPUNLESS, label))
                    self.codes.append((ins.DELCTX, None))
                elif la1 and la1 in [LITERAL]:
                    pass
                    l = self.LT(1)
                    self.match(LITERAL)
                    st = l.getText()
                    b = (ins.STRING, st)
                    self.codes.append(b)
                elif la1 and la1 in [INCLUDE]:
                    pass
                    inc = self.LT(1)
                    self.match(INCLUDE)
                    for token in SmartyExprLexer.Lexer(StringIO(inc.getText())):
                       b = (ins.INCLUDE, token.getText())
                       self.codes.append(b)
                else:
                        break
                    
        
        except antlr.RecognitionException, ex:
            self.reportError(ex)
            self.consume()
            self.consumeUntil(_tokenSet_0)
        
    

_tokenNames = [
    "<0>", 
    "EOF", 
    "<2>", 
    "NULL_TREE_LOOKAHEAD", 
    "IF", 
    "IFNOT", 
    "ELSEIF", 
    "ELSE", 
    "ENDIF", 
    "FOREACH", 
    "ENDFOR", 
    "INCLUDE", 
    "EXPR", 
    "LITERAL", 
    "ACTION", 
    "NL", 
    "COMMENT", 
    "IF_EXPR", 
    "FILTER", 
    "FILTER_ARGS", 
    "VARIABLE", 
    "FOREACH_EXPR", 
    "LOOP_VAR", 
    "LOOP_ITEM", 
    "LOOP_NAME", 
    "INC_EXPR", 
    "NO_ESC", 
    "SYMBOL"
]
    

### generate bit set
def mk_tokenSet_0(): 
    ### var1
    data = [ 2L, 0L]
    return data
_tokenSet_0 = antlr.BitSet(mk_tokenSet_0())
    
