# coding: utf-8
from caty.template.core.template import Template
from caty.template.core.loader import BytecodeLoader, TextBytecodePersister
from caty.template.core.compiler import Compiler
from caty.template.core.io import ResourceIO
from caty.template.smarty.SmartyLexer import Lexer
from caty.template.smarty.SmartyParser import Parser
from caty.template.builder import build_template
__all__ = ['SmartyTemplate', 'build_compiler']
def SmartyTemplate(template):
    u"""スタンドアローンで動作する（他の caty モジュールに依存しない） Smarty 用テンプレートエンジンを作成する。
    """
    compiler = build_compiler()
    resource_io = ResourceIO()
    resource_io.set_default_encoding(encoding)
    t = build_template(compiler, ResourceIO())
    t.set_template(template)
    return t

def build_compiler():
    u"""リソース IO やローダーまでは初期化せず、
    テンプレートのコンパイラまでを作成する。
    """
    compiler = Compiler(Lexer, Parser)
    return compiler

