# coding: utf-8
import sys
import os
sys.path.append(os.path.abspath('../../../../'))
import unittest
import codecs
from StringIO import StringIO
from caty.template.smarty import SmartyParser, SmartyLexer, SmartyTemplate
from caty.template.core.vm import VirtualMachine

class SmartyLexerTest(unittest.TestCase):
    def testLexer(self):
        lexer = SmartyLexer.Lexer(codecs.getreader('utf-8')(open('test.html')))
        tokens = list(lexer)
        token_types = [t.getType() for t in tokens]
        self.assertTrue(token_types.count(SmartyLexer.EXPR) == 12)
        self.assertTrue(token_types.count(SmartyLexer.IF) == 1)
        self.assertTrue(token_types.count(SmartyLexer.ELSEIF) == 1)
        self.assertTrue(token_types.count(SmartyLexer.ENDIF) == 1)
        self.assertTrue(token_types.count(SmartyLexer.FOREACH) == 1)
        self.assertTrue(token_types.count(SmartyLexer.ENDFOR) == 1)
        self.assertTrue(token_types.count(SmartyLexer.INCLUDE) == 1)

if __name__ == '__main__': 
    result = unittest.TestResult()
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(SmartyLexerTest))
    suite.run(result)
    if not result.wasSuccessful():
        print '--------\n'.join(('%s:\n%s' % (f[0]._testMethodName, f[1]) for f in result.failures + result.errors))

