# coding: utf-8
from caty import mafs
from caty.mafs.authorization import AuthoriToken
import caty.jsontools as json
from caty.util import merge_dict, memoize

import os.path
# /public 以下のファイルだけを読むので、 auth token はゲスト権限で良い
fs = mafs.filesystem.bind_token(AuthoriToken('guest'))

__all__ = ['merge_config', 'is_hidden_path']

def merge_config(path, config):
    conffile = '_filetypes.json'
    d, _ = os.path.split(path)
    f = os.path.join(d, conffile)
    fo = fs.FileObject(f, 'rb')
    if fo.exists:
        newconf = json.loads(fo.read())
    else:
        newconf = {}
    merge_dict(config, newconf)
    if d != '/':
        return merge_config(d, config)
    else:
        return config

def is_hidden_path(path):
    if path == '/':
        return False
    d, f = os.path.split(path)
    if f.startswith('_'):
        return True
    else:
        return is_hidden_path(d)
